#include <SPI.h>;
#include <Ethernet.h>;

const int sensorMin = 0;     // sensor minimum
const int sensorMax = 1024;  // sensor maximum

void setup() {
  pinMode(9, OUTPUT);
  Serial.begin(9600);  
  setupComm();
}
void loop() {

  int sensorReading = analogRead(A1);
  int j=0;
  int sensorValue = 0;
  sensorValue = analogRead(A0);
  //Serial.println(sensorValue, DEC);
 
  int range = map(sensorReading, sensorMin, sensorMax, 0, 3);
  
  switch (range) {
  case 0:    // A fire closer than 1.5 feet away.
    Serial.println("Vatra u blizini");
    email("Doslo je do pozara u blizini!");
    for ( ;j<25;j++) beep(200);
    break;
  case 1:    // A fire between 1-3 feet away.
    Serial.println("Vatra");
    email("Doslo je do pozara!");
    for ( ;j<25;j++) beep(200); 
    break;
  case 2:    // No fire detected.
    Serial.println("Nema vatre");
    break;
  }
  
  if (sensorValue > 400){
  email("Detektirana pojava plina!");
  for ( ;j<25;j++) beep(200);
  }
  else Serial.println("Nema dima ni drugih plinova");
  
  delay(1000);  // delay between reads
  
  
}


 
// Arduino network information
byte mac[] = {   0x90, 0xA2, 0xDA, 0x0D, 0xA5, 0xEF };
EthernetClient client;
char smtpServer[] = "smtpcorp.com";

void setupComm()
{
  Serial.println("Trying to connect");
  if (!Ethernet.begin(mac)){
    Serial.println("Failed to DHCP");
    // verifyng connection
    while(true);
  }
  delay(10000);
  // IP address is:
  Serial.print("IP address: ");
  for (byte thisByte = 0; thisByte < 4; thisByte++) {
    Serial.print(Ethernet.localIP()[thisByte], DEC);
    Serial.print(".");
  }
  Serial.println();
}

bool email(char* text)
{
  bool success = false;
  Serial.println("Sending email...");
  if (client.connect(smtpServer, 2525)){            //2525 is SMTP Server port
    Serial.println("connected");
    delay(100);
    client.println("EHLO arduino");
    for(int i=0; i<999; ++i){
      if(client.read() > 0)
        break;
    }
    Serial.println("responded");
    client.println("AUTH LOGIN");                     
    client.println("emphbGljLnplbGprYUBnbWFpbC5jb20=");                   
    client.println("TmlydmFuYTU=");                   
    // Put your "from" email address here
    client.println("MAIL FROM:<zjalic.zeljka@gmail.com>");
    for(int i=0; i<999; ++i){
      if(client.read() > 0)
        break;
    }
    client.println("RCPT TO:<zeljka.zjalic@fer.hr>");
    for(int i=0; i<999; ++i){
      if(client.read() > 0)
        break;
    }
    client.println("DATA");
    for(int i=0; i<999; ++i){
      if(client.read() > 0)
        break;
    }
    //Sender
    client.println("from: zjalic.zeljka@gmail.com"); //Sender address
    client.println("to: zeljka.zjalic@fer.hr");  //Receiver address
    client.println("SUBJECT: From arduino");
    client.println("");
    client.println(text);
    client.println(".");
    client.println("QUIT");
    for (int i = 0; i<999; ++i){
      if(i > 998){
        Serial.println("error: No response");
      }
      if(client.read() > 0)
        break;
    }
    success = true;
    client.println();
    Serial.println("end");
  }
  else {
    Serial.println("Failed");
    client.println("QUIT"); //Disconnection
  }
  client.stop();
  return success;
}

void beep(unsigned char delayms){
  analogWrite(9, 20);      // Almost any value can be used except 0 and 255                       
  delay(delayms);          // wait for a delayms ms
  analogWrite(9, 0);       // 0 turns it off
  delay(delayms);          // wait for a delayms ms
 
}  

